import * as Types from "./";
import { Client, InvokeApiResult } from "@web3api/core-js";
export declare type UInt = number;
export declare type UInt8 = number;
export declare type UInt16 = number;
export declare type UInt32 = number;
export declare type Int = number;
export declare type Int8 = number;
export declare type Int16 = number;
export declare type Int32 = number;
export declare type Bytes = Uint8Array;
export declare type BigInt = string;
export declare type Json = string;
export declare type String = string;
export declare type Boolean = boolean;
export interface QueryEnv extends Record<string, unknown> {
    disableParallelRequests?: boolean | null;
}
export interface ResolveResult {
    cid: string;
    provider: string;
}
export interface Options {
    timeout?: UInt32 | null;
    provider?: string | null;
    disableParallelRequests?: boolean | null;
}
export interface UriResolver_MaybeUriOrManifest {
    uri?: string | null;
    manifest?: string | null;
}
interface UriResolver_Query_Input_tryResolveUri extends Record<string, unknown> {
    authority: string;
    path: string;
}
interface UriResolver_Query_Input_getFile extends Record<string, unknown> {
    path: string;
}
export declare const UriResolver_Query: {
    tryResolveUri: (input: UriResolver_Query_Input_tryResolveUri, client: Client) => Promise<InvokeApiResult<Types.UriResolver_MaybeUriOrManifest | null>>;
    getFile: (input: UriResolver_Query_Input_getFile, client: Client) => Promise<InvokeApiResult<Bytes | null>>;
};
export {};
